//
// $Id: quadtree.h 101 2008-07-10 09:20:12Z mrchip $
//
// Copyright (C) 2005 STADT-LAND-FLUSS INGENIEURDIENSTE GmbH
//
// Authors:
// Ulrich Kiel <u.kiel@S-L-F.de>
//
// This program is free software under the GPL (>=v2)
// Read the file COPYING coming with WSPLGEN for details.
//

//---------------------------------------------------------------------------
#ifndef quadtreeH
#define quadtreeH

//----------------------------------------------------------------------------
// TQuadTree
//----------------------------------------------------------------------------
template <class TXyList, class TXy> class TQuadTree
{
	public:
		TQuadTree	*NW;
		TQuadTree	*NE;
		TQuadTree	*SW;
		TQuadTree	*SE;

		TXy			*Xy;

		TQuadTree(void);
		TQuadTree(TXy *xy);
		~TQuadTree(void);

		// Insert liefert true zurck, wenn das Objekt eingefgt werden konnte,
		// und false, falls es schon eingefgt war
		bool 		Insert(long XMin, long XMax, long YMin, long YMax, TXy *xy);
		int 		ListAll(void);
		TXy*		Search(long X, long Y, long XMin, long XMax, long YMin, long YMax);
		int			SearchAll(double X, double Y, double R, TXyList* FoundXyList, long XMin, long XMax, long YMin, long YMax);
};

#endif

